CREATE SEQUENCE "$SCHEMA$"."EVENT_SEQUENCE" AS DECIMAL(16,0) START WITH 1 INCREMENT BY 1 NO MAXVALUE ORDER $

DROP INDEX "$SCHEMA$"."HS_ADT_TRL_INDEX" $

CREATE INDEX "$SCHEMA$"."HS_AT_SEQ_INDEX" ON "$SCHEMA$"."HS_AUDIT_TRAIL"("EVENT_SEQ") $

DROP TRIGGER "$SCHEMA$"."AT_INST" $

CREATE TRIGGER "$SCHEMA$"."AT_INST" AFTER INSERT ON "$SCHEMA$"."AUDIT_TRAIL"
 REFERENCING NEW AS NEW_REC FOR EACH ROW 
 MODE DB2SQL BEGIN ATOMIC
 INSERT INTO $SCHEMA$.HS_AUDIT_TRAIL
 (EVENT_SEQ, CREATED, EVENT, TEMPL_VALID_FROM, PROCESS_NAME, PROCESS_ID, TOP_LVL_PROC_NAME,
 TOP_LVL_PROC_ID, PARENT_PROC_NAME, PARENT_PROC_ID, PROC_TEMPL_NAME, BLOCK_NAMES,
 USER_NAME, SECOND_USER_NAME, ACTIVITY_NAME, ACTIVITY_TYPE, ACTIVITY_STATE,
 COMMAND_PARAMETERS, PROGRAM_NAME, ACTIVITY_RC, ASSOCIATED_OBJECT,
 OBJECT_DESCRIPTION, SECOND_ACT_NAME, EXTERNAL_CONTEXT)
 VALUES
 (NEXTVAL FOR $SCHEMA$.EVENT_SEQUENCE, NEW_REC.CREATED, NEW_REC.EVENT, NEW_REC.TEMPL_VALID_FROM,
 NEW_REC.PROCESS_NAME, NEW_REC.PROCESS_ID, NEW_REC.TOP_LVL_PROC_NAME,
 NEW_REC.TOP_LVL_PROC_ID, NEW_REC.PARENT_PROC_NAME, NEW_REC.PARENT_PROC_ID,
 NEW_REC.PROC_TEMPL_NAME, NEW_REC.BLOCK_NAMES, NEW_REC.USER_NAME,
 NEW_REC.SECOND_USER_NAME, NEW_REC.ACTIVITY_NAME, NEW_REC.ACTIVITY_TYPE,
 NEW_REC.ACTIVITY_STATE, NEW_REC.COMMAND_PARAMETERS, NEW_REC.PROGRAM_NAME,
 NEW_REC.ACTIVITY_RC, NEW_REC.ASSOCIATED_OBJECT, NEW_REC.OBJECT_DESCRIPTION,
 NEW_REC.SECOND_ACT_NAME, NEW_REC.EXTERNAL_CONTEXT);
 END $
