CREATE SEQUENCE "$SCHEMA$"."PROC_DATA_SEQUENCE" MINVALUE 1 NOMAXVALUE ORDER;

ALTER TABLE "$SCHEMA$"."HS_PROC_DATA" ADD(PROC_DATA_SEQ NUMBER(16) DEFAULT 0 NOT NULL);

ALTER TABLE "$SCHEMA$"."HS_CONT_DETAIL" ADD(CONT_DETAIL_SEQ NUMBER(16) DEFAULT 0 NOT NULL);

ALTER TABLE "$SCHEMA$"."HS_PROC_DATA" DROP PRIMARY KEY;

ALTER TABLE "$SCHEMA$"."HS_CONT_DETAIL" DROP PRIMARY KEY;

CREATE INDEX "$SCHEMA$"."HS_PD_SEQ_INDEX" ON "$SCHEMA$"."HS_PROC_DATA"(PROC_DATA_SEQ);

CREATE INDEX "$SCHEMA$"."HS_PDD_SEQ_INDEX" ON "$SCHEMA$"."HS_CONT_DETAIL"(CONT_DETAIL_SEQ);

CREATE OR REPLACE TRIGGER "$SCHEMA$"."PD_INST" AFTER INSERT ON "$SCHEMA$"."CONTAINER" REFERENCING NEW AS PD FOR EACH ROW 
 BEGIN
 INSERT INTO
 $SCHEMA$.HS_PROC_DATA(PROC_DATA_SEQ, BIID, CIID, LAST_UPDATED, SHORT_DATA)
 VALUES
 (PROC_DATA_SEQUENCE.NEXTVAL, :PD.BIID, :PD.CIID, :PD.LAST_UPDATED, :PD.SHORT_DATA);
 END;
/ 

CREATE OR REPLACE TRIGGER "$SCHEMA$"."PD_UPDT" AFTER UPDATE ON "$SCHEMA$"."CONTAINER" REFERENCING NEW AS PD FOR EACH ROW 
 BEGIN
 INSERT INTO $SCHEMA$.HS_PROC_DATA(PROC_DATA_SEQ, BIID, CIID, LAST_UPDATED, SHORT_DATA)
 VALUES
 (PROC_DATA_SEQUENCE.NEXTVAL, :PD.BIID, :PD.CIID, :PD.LAST_UPDATED, :PD.SHORT_DATA);
 END;
/ 

CREATE OR REPLACE TRIGGER "$SCHEMA$"."PDD_INST" AFTER INSERT ON "$SCHEMA$"."CONTAINER_DATA_SEG" REFERENCING NEW AS PD FOR EACH ROW 
 BEGIN
 INSERT INTO
 $SCHEMA$.HS_CONT_DETAIL(CONT_DETAIL_SEQ, CD_BIID, CD_CIID, CD_LAST_UPDATED, SEQ_NUM, DATA)
 VALUES
 (PROC_DATA_SEQUENCE.NEXTVAL, :PD.BIID, :PD.CIID, TIMESTAMP_WF(SYSDATE, 0), :PD.SEQ_NUM, :PD.DATA);
 END;
/ 

CREATE OR REPLACE TRIGGER "$SCHEMA$"."PDD_UPDT" AFTER UPDATE ON "$SCHEMA$"."CONTAINER_DATA_SEG" REFERENCING NEW AS PD FOR EACH ROW 
 BEGIN
 INSERT INTO
 $SCHEMA$.HS_CONT_DETAIL(CONT_DETAIL_SEQ, CD_BIID, CD_CIID, CD_LAST_UPDATED, SEQ_NUM, DATA)
 VALUES
 (PROC_DATA_SEQUENCE.NEXTVAL, :PD.BIID, :PD.CIID, TIMESTAMP_WF(SYSDATE, 0), :PD.SEQ_NUM, :PD.DATA);
 END;
/

DROP SEQUENCE "$SCHEMA$"."TIMESTAMP_SEQ";

DROP SEQUENCE "$SCHEMA$"."GENERIC_SEQ";

CREATE OR REPLACE PROCEDURE UPDATE_HS_PROC_DATA
IS
v_counter number;
v_total number;
CURSOR C1 IS SELECT DISTINCT A.BIID,A.CIID,A.LAST_UPDATED.D DT, A.LAST_UPDATED.S FR
FROM $SCHEMA$.HS_PROC_DATA A
ORDER BY A.BIID,A.CIID,A.LAST_UPDATED.D, A.LAST_UPDATED.S;
BEGIN
SELECT COUNT(*) INTO v_total FROM $SCHEMA$.HS_PROC_DATA;
v_counter := 1;
FOR REC1 IN C1
LOOP
UPDATE $SCHEMA$.HS_PROC_DATA A SET PROC_DATA_SEQ = -1 * v_total
WHERE A.BIID=REC1.BIID AND A.CIID = REC1.CIID AND A.LAST_UPDATED.D = REC1.DT AND A.LAST_UPDATED.S = REC1.FR;
v_total := v_total - 1;
v_counter := v_counter + 1;
IF (v_counter > 1000)
THEN
COMMIT;
v_counter := 1;
END IF;
END LOOP;
COMMIT;
END;
/

CREATE OR REPLACE PROCEDURE UPDATE_HS_CONT_DETAIL
IS
v_counter number;
v_total number;
CURSOR C1 IS SELECT DISTINCT A.CD_BIID,A.CD_CIID,A.CD_LAST_UPDATED.D DT, A.CD_LAST_UPDATED.S FR,A.SEQ_NUM
FROM $SCHEMA$.HS_CONT_DETAIL A 
ORDER BY A.CD_BIID,A.CD_CIID,A.CD_LAST_UPDATED.D, A.CD_LAST_UPDATED.S,A.SEQ_NUM;
BEGIN
SELECT COUNT(*) INTO v_total FROM $SCHEMA$.HS_CONT_DETAIL;
v_counter := 1;
FOR REC1 IN C1
LOOP
UPDATE $SCHEMA$.HS_CONT_DETAIL A SET CONT_DETAIL_SEQ = -1 * v_total
WHERE A.CD_BIID=REC1.CD_BIID AND A.CD_CIID = REC1.CD_CIID AND A.CD_LAST_UPDATED.D = REC1.DT AND A.CD_LAST_UPDATED.S = REC1.FR AND A.SEQ_NUM = REC1.SEQ_NUM ;
v_total := v_total - 1;
v_counter := v_counter + 1;
IF (v_counter > 1000)
THEN
COMMIT;
v_counter := 1;
END IF;
END LOOP;
COMMIT;
END;
/

EXECUTE UPDATE_HS_PROC_DATA()

EXECUTE UPDATE_HS_CONT_DETAIL()

DROP PROCEDURE UPDATE_HS_PROC_DATA;

DROP PROCEDURE UPDATE_HS_CONT_DETAIL;
